// File "patches.h" - 

#ifndef __PATCHES_HEADER__
#define __PATCHES_HEADER__

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Include Files */

#include "stdtypes.h"

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Preprocessor Defines */


/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Structure/Class Definitions */

// Setup calling information for the routines we need
#if !GENERATINGCFM
typedef pascal void (*ExitToShellProcPtr)();
typedef ExitToShellProcPtr ExitToShellUPP;
enum {
	uppExitToShellProcInfo = 0
	};
#define NewExitToShellProc(proc) (ExitToShellUPP)(proc)
#define CallExitToShellProc(proc) (* (ExitToShellProcPtr) (proc))()
#else
typedef UniversalProcPtr ExitToShellUPP;
enum {
	uppExitToShellProcInfo = kPascalStackBased
	};
#define NewExitToShellProc(proc) (ExitToShellUPP) \
		NewRoutineDescriptor((ProcPtr)(proc), uppExitToShellProcInfo, GetCurrentISA())
#define CallExitToShellProc(proc) \
		CallUniversalProc((UniversalProcPtr) (proc), uppExitToShellProcInfo)
#endif GENERATINGCFM

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */

typedef void (*E2STaskProc)(void *taskData);

typedef struct E2STask {
	struct E2STask *qLink;
	E2STaskProc proc; // Not a UPP
	void *data;
	} E2STask, *E2STaskPtr;
	
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Function Prototypes */

#ifdef __cplusplus
extern "C" {
#endif

SInt32 InstallE2STask(E2STaskProc taskProc, void *taskData);
void RemoveE2STask(E2STaskProc taskProc, void *taskData);

#ifdef __cplusplus
}
#endif

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */

#endif /* __PATCHES_HEADER__ */
