/* File "platform.cp", Light Sockets - Copyright (C) Matt Slot, 1996          */
/* Platform specific utilities for registering and selecting network stacks.  */

#ifndef __PLATFORM_HEADER__
#define __PLATFORM_HEADER__

#ifndef __STD_TYPES_HEADER__
#include "stdtypes.h"
#endif /* __STD_TYPES_HEADER__ */

#ifndef __SOCKET_HEADER__
#include "socket.h"
#endif /* __SOCKET_HEADER__ */

#ifndef __NET_STACK_HEADER__
#include "netstack.h"
#endif /* __NET_STACK_HEADER__ */

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Preprocessor Defines */


/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Enum/Structure/Class Definitions */


/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Function Prototypes */

#ifdef __cplusplus
extern "C" {
#endif

SocketResult SelectNetworkStack(SocketRef socket, NetworkStackRef &stack);

SocketResult ResolveNetworkAddress(SocketType suggType, Char8 *textAddress,
		SocketAddressPtr socketAddress);
SocketResult LookupNetworkAddress(SocketAddressPtr socketAddress, 
		Char8 *textAddress);

#ifdef __cplusplus
    }
#endif

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */

#endif /* __PLATFORM_HEADER__ */

