/* File "client.h", ISR/Reggie - Copyright (C) Matt Slot+Mike Monan, 1996     */
/* Fundamental networking header for the Internet Service Registry (reggie)   */

#ifndef __CLIENT_HEADER__
#define __CLIENT_HEADER__

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Include Files */

#include "stdtypes.h"

#include "reggie.h"
#include "socket.h"

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Preprocessor Defines */

#define	kRegEntryCount	50

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Structure/Class Declarations */

typedef struct RegEntry {
	ServiceAddress		serviceAddr;
	Char8				serviceType[20];
	Char8				serviceName[256];
	Char8				serviceInfo[256];
	} RegEntry, *RegEntryPtr;

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Function Prototypes */

SInt32 DumpRegEntries(void);
SInt32 QueryTracker(UInt32 transactionID, UInt32 startIndex, UInt32 endIndex,
		Char8 *typeMask, Char8 *nameMask, Char8 *infoMask, Char8 *trackerName);
SInt32 HandlePacket(DatagramSocket *socket, void *refcon,
		PacketPtr rcvPacket, UInt32 packetLen, SocketAddressPtr remoteAddr);

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */

#endif /* __CLIENT_HEADER__ */
