/* File "tracker.h", ISR/Reggie - Copyright (C) Matt Slot+Mike Monan, 1996    */
/* Fundamental networking header for the Internet Service Registry (reggie)   */

#ifndef __TRACKER_HEADER__
#define __TRACKER_HEADER__

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Include Files */

#include "stdtypes.h"

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Preprocessor Defines */


/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Structure/Class Declarations */

typedef struct DBData {
	UInt32				servicePing;
	UInt32				serviceTTL;
	ServiceAddress  	serviceAddr;
	Char8				serviceType[20];
	Char8				serviceName[256];
	Char8				serviceInfo[256];
	} DBData, *DBDataPtr;

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* Function Prototypes */

SInt32 InitDB(void);
SInt32 IdleLoop(void);
SInt32 HandlePacket(DatagramSocket *socket, void *refcon,
		PacketPtr packet, UInt32 packetLen, SocketAddressPtr remoteAddr);
		
SInt32 RegisterService(UInt32 serviceTTL, ServiceAddressPtr serviceAddr, 
		Char8 *serviceType, Char8 *serviceName, Char8 *serviceInfo);
SInt32 TickleService(void);
SInt32 DeleteService(ServiceAddressPtr serviceAddr, 
		Char8 *serviceType, Char8 *serviceName, Char8 *serviceInfo);
SInt32 FindServices(DatagramSocketRef socket, SocketAddressPtr remoteAddr,
		UInt32 transactionID, UInt32 startIndex, UInt32 stopIndex,
		Char8 *serviceType, Char8 *serviceName, Char8 *serviceInfo);

SInt32 SendAckPacket(DatagramSocket *socket, SocketAddressPtr remoteAddr,
		UInt32 transactionID);

/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */
/* **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** */

#endif /* __TRACKER_HEADER__ */
